import java.awt.Graphics;
/*
 * GridPanel, which keeps track of the grid and will be instructed add particles in certain places and also to move and draw. 
 *  The draw and move methods are taken care of.  You only need to write: addParticle.  
ourGrid is originally 100X100 of Particles, which originally is all null.
 */
public class GridPanel {
	private Particle[][] grid;  //2d array of Particles (originally null)

	public GridPanel(int rows,int cols) {
		this.grid = new Particle[rows][cols];
	}

	public void drawGrid(Graphics g){
		for (int r=0;r<grid.length;r++)
			for (int c=0;c<grid.length;c++)
				if (grid[r][c]!=null)
					grid[r][c].draw(g,r,c);
	}

	public void moveParticles(){
		//before everyone has moved,lets reset that variable to false
		for (int r=0;r<grid.length;r++)
			for (int c=0;c<grid.length;c++)
				if (grid[r][c]!=null)
					grid[r][c].setHasMoved(false);

		//now move them all (after moving, set moved to true
		for (int r=0;r<grid.length;r++)
			for (int c=0;c<grid.length;c++)
				if (grid[r][c]!=null && !grid[r][c].getHasMoved())
				{	
					Particle p=grid[r][c];
					p.move(grid);
					p.setHasMoved(true);
				}
	}	

	//addParticle will create a specific Particle and put that in ourGrid at r,c  
	//type will be "Sand", "Rock", "Floater"
	public void addParticle(int r, int c, String type) {
		// TO BE IMPLEMENTED IN B	
		if (type.equals("Rock"))
			grid[r][c]=new Rock(r,c);
	}


}
