import java.awt.Color;
import java.awt.Graphics;
/*
 * Particle, this class keeps track of one particle.  A Particle keeps track of r,c and color 
 * (Color can be red,yellow,green, blue, brown, gray).  
 * The constructor will take all those things in.  There is a draw, move and setLocation methods. 
 *  There are getters for row,col. There is an abstract method - move - which you will need to write
 *   differently depending on the Particle type you are making.  
 */
public abstract class Particle {
	private Color particleColor=Color.black; //default color will be black, if you enter an invalid color in constructor
	private int row;
	private int col;
	private boolean hasMoved=false;
	
	
	//feel free to add additional colors
	public Particle(int row, int col, String color) {	
		this.row = row;
		this.col = col;
		if (color.equals("red"))
			particleColor=Color.red;
		if (color.equals("gray"))
			particleColor=Color.gray;
		if (color.equals("blue"))
			particleColor=Color.blue;
		if (color.equals("yellow"))
			particleColor=Color.yellow;
		if (color.equals("green"))
			particleColor=Color.green;
		if (color.equals("brown"))
			particleColor=new Color(96, 82, 25);
		
	}

	//Any class the extends Particle will need to write a constructor and the following method
	
	public abstract void move(Particle[][] grid);

	//you wont motify any of the following
	public void draw(Graphics g, int row, int col)
	{
		g.setColor(particleColor);
		g.fillRect(col*ParticleRunner.PARTICLE_WIDTH+ParticleRunner.SPACER, row*ParticleRunner.PARTICLE_WIDTH+ParticleRunner.SPACER+20, 
				ParticleRunner.PARTICLE_WIDTH, ParticleRunner.PARTICLE_WIDTH);
	}

	public int getRow() {
		return row;
	}

	public int getCol() {
		return col;
	}

	public void setLocation(int row, int col) {
		this.row = row;
		this.col = col;
	}

	public boolean getHasMoved() {
		return hasMoved;
	}

	public void setHasMoved(boolean hasMoved) {
		this.hasMoved = hasMoved;
	}
	
	
	

	
	

}
