import javax.swing.UIManager.LookAndFeelInfo;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.event.MouseWheelEvent;
import java.awt.event.MouseWheelListener;
import javax.swing.border.Border;
import java.awt.image.*;
import java.util.Scanner; 
import javax.swing.*;


/**
ParticleRunner, this is what runs the project, you will edit nothing here (unless you want).  
It manages the mouse and animation.  Each frame, it will call GridPanels move and draw methods.  
It also will deal with mouse dragged, which when happens, will tell GridPanel to add the type of 
particle (sand, rock, floater) to the Grid.
 **/

public class ParticleRunner extends BorlandBase {

	public static final int SPACER=20;
	public static final int PARTICLE_WIDTH = 6; //how many pixels the particles are
	private JPanel panel1;
	private JComboBox particuleChoice;
	private static final int GRID_SIZE=600;  //default grid size (its a square)
	private static final int DELAY=100; //delay, we might want to change this
	private GridPanel ourGrid=new GridPanel(GRID_SIZE/PARTICLE_WIDTH,GRID_SIZE/PARTICLE_WIDTH);
	//Constructor 
	public void initialize(){

		setWidth(GRID_SIZE+100);
		setHeight(GRID_SIZE+200);
		setScreenLayout(null);
		setBackgroundColor(new Color(192,192,192));


		panel1 = new JPanel(null);
		panel1.setBorder(BorderFactory.createEtchedBorder(1));
		panel1.setBounds(SPACER,SPACER,GRID_SIZE,GRID_SIZE);
		panel1.setBackground(new Color(214,217,223));
		panel1.setForeground(new Color(0,0,0));
		panel1.setEnabled(true);
		panel1.setFont(new Font("sansserif",0,12));
		panel1.setVisible(true);

		String[] particuleChoice_options = { "Sand", "Floater","Rock"};
		particuleChoice = new JComboBox<>(particuleChoice_options);
		particuleChoice.setBounds(27,GRID_SIZE+50,90,35);
		particuleChoice.setBackground(new Color(214,217,223));
		particuleChoice.setForeground(new Color(0,0,0));
		particuleChoice.setEnabled(true);
		particuleChoice.setFont(new Font("sansserif",0,12));
		particuleChoice.setVisible(true);

		//Below is for animation
		setAnimation(true);
		setDelay(DELAY);


		//adding components to contentPane panel
		addItem(panel1);
		addItem(particuleChoice);
	}

	//If the mouse button is clicked, this method is called 
	public void mouseDragged(MouseEvent e)
	{
		int x=e.getX();
		int y=e.getY();
		String type=particuleChoice.getSelectedItem().toString();
		if (y-SPACER>=0 && y-SPACER-20<GRID_SIZE && x-SPACER>0 && x-SPACER<GRID_SIZE)
			ourGrid.addParticle((y-SPACER-20)/PARTICLE_WIDTH,(x-SPACER)/PARTICLE_WIDTH,type);

	}

	//The method below will get called every frame. 
	//its parameter g is the temporary graphics layer 
	public void update(Graphics g)
	{
		//put your code for what should happen each animation
		ourGrid.moveParticles();
		ourGrid.drawGrid(g);
	}

	public static void main(String[] args){
		try{  BorlandBase.main((BorlandBase)(new Object() { }.getClass().getEnclosingClass().newInstance()));  }
		catch (Exception e){e.printStackTrace();}
	}

}